# coding: utf-8

"""
    Firefly III API Client

    This is the Python client for Firefly III API

    The version of the OpenAPI document: v6.2.21
    Contact: james@firefly-iii.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firefly_iii_client.models.auto_budget_period import AutoBudgetPeriod
from firefly_iii_client.models.auto_budget_type import AutoBudgetType
from firefly_iii_client.models.budget_spent import BudgetSpent
from typing import Optional, Set
from typing_extensions import Self

class Budget(BaseModel):
    """
    Budget
    """ # noqa: E501
    active: Optional[StrictBool] = None
    auto_budget_amount: Optional[StrictStr] = Field(default=None, description="The amount for the auto-budget, if set.")
    auto_budget_period: Optional[AutoBudgetPeriod] = None
    auto_budget_type: Optional[AutoBudgetType] = None
    created_at: Optional[datetime] = None
    currency_code: Optional[StrictStr] = Field(default=None, description="The currency code that is part of the budget's auto-budget settings, if any.")
    currency_decimal_places: Optional[StrictInt] = Field(default=None, description="The currency decimal places that is part of the budget's auto-budget settings, if any.")
    currency_id: Optional[StrictStr] = Field(default=None, description="The currency ID that is part of the budget's auto-budget settings, if any.")
    currency_symbol: Optional[StrictStr] = Field(default=None, description="The currency symbol that is part of the budget's auto-budget settings, if any.")
    name: StrictStr
    native_auto_budget_amount: Optional[StrictStr] = Field(default=None, description="The native amount for the auto-budget, if set.")
    native_currency_code: Optional[StrictStr] = Field(default=None, description="The administration's native currency code.")
    native_currency_decimal_places: Optional[StrictInt] = Field(default=None, description="The administration's native currency decimal places.")
    native_currency_id: Optional[StrictStr] = Field(default=None, description="The administration's native currency ID.")
    native_currency_symbol: Optional[StrictStr] = Field(default=None, description="The administration's native currency symbol.")
    notes: Optional[StrictStr] = None
    order: Optional[StrictInt] = None
    spent: Optional[List[BudgetSpent]] = Field(default=None, description="Information on how much was spent in this budget. Is only filled in when the start and end date are submitted.")
    updated_at: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["active", "auto_budget_amount", "auto_budget_period", "auto_budget_type", "created_at", "currency_code", "currency_decimal_places", "currency_id", "currency_symbol", "name", "native_auto_budget_amount", "native_currency_code", "native_currency_decimal_places", "native_currency_id", "native_currency_symbol", "notes", "order", "spent", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Budget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "created_at",
            "currency_decimal_places",
            "currency_symbol",
            "native_currency_code",
            "native_currency_decimal_places",
            "native_currency_id",
            "native_currency_symbol",
            "order",
            "spent",
            "updated_at",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in spent (list)
        _items = []
        if self.spent:
            for _item_spent in self.spent:
                if _item_spent:
                    _items.append(_item_spent.to_dict())
            _dict['spent'] = _items
        # set to None if auto_budget_amount (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_amount is None and "auto_budget_amount" in self.model_fields_set:
            _dict['auto_budget_amount'] = None

        # set to None if auto_budget_period (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_period is None and "auto_budget_period" in self.model_fields_set:
            _dict['auto_budget_period'] = None

        # set to None if auto_budget_type (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_type is None and "auto_budget_type" in self.model_fields_set:
            _dict['auto_budget_type'] = None

        # set to None if currency_code (nullable) is None
        # and model_fields_set contains the field
        if self.currency_code is None and "currency_code" in self.model_fields_set:
            _dict['currency_code'] = None

        # set to None if currency_decimal_places (nullable) is None
        # and model_fields_set contains the field
        if self.currency_decimal_places is None and "currency_decimal_places" in self.model_fields_set:
            _dict['currency_decimal_places'] = None

        # set to None if currency_id (nullable) is None
        # and model_fields_set contains the field
        if self.currency_id is None and "currency_id" in self.model_fields_set:
            _dict['currency_id'] = None

        # set to None if currency_symbol (nullable) is None
        # and model_fields_set contains the field
        if self.currency_symbol is None and "currency_symbol" in self.model_fields_set:
            _dict['currency_symbol'] = None

        # set to None if native_auto_budget_amount (nullable) is None
        # and model_fields_set contains the field
        if self.native_auto_budget_amount is None and "native_auto_budget_amount" in self.model_fields_set:
            _dict['native_auto_budget_amount'] = None

        # set to None if notes (nullable) is None
        # and model_fields_set contains the field
        if self.notes is None and "notes" in self.model_fields_set:
            _dict['notes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Budget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "auto_budget_amount": obj.get("auto_budget_amount"),
            "auto_budget_period": obj.get("auto_budget_period"),
            "auto_budget_type": obj.get("auto_budget_type"),
            "created_at": obj.get("created_at"),
            "currency_code": obj.get("currency_code"),
            "currency_decimal_places": obj.get("currency_decimal_places"),
            "currency_id": obj.get("currency_id"),
            "currency_symbol": obj.get("currency_symbol"),
            "name": obj.get("name"),
            "native_auto_budget_amount": obj.get("native_auto_budget_amount"),
            "native_currency_code": obj.get("native_currency_code"),
            "native_currency_decimal_places": obj.get("native_currency_decimal_places"),
            "native_currency_id": obj.get("native_currency_id"),
            "native_currency_symbol": obj.get("native_currency_symbol"),
            "notes": obj.get("notes"),
            "order": obj.get("order"),
            "spent": [BudgetSpent.from_dict(_item) for _item in obj["spent"]] if obj.get("spent") is not None else None,
            "updated_at": obj.get("updated_at")
        })
        return _obj


